# Flock Architecture Diagrams

This directory contains architectural diagrams that illustrate different aspects of the Flock framework.

## Core Architecture
[core-architecture.md](core-architecture.md)
- Overall system architecture
- Component relationships
- External integrations
- System boundaries

## Agent Workflow
[agent-workflow.md](agent-workflow.md)
- Agent execution sequence
- Local vs production modes
- Tool usage patterns
- Hand-off mechanisms

## Type System
[type-system.md](type-system.md)
- Type system class structure
- Validation flow
- Component relationships
- Type management

## Tool System
[tool-system.md](tool-system.md)
- Tool management architecture
- Tool execution flow
- Error handling
- External integrations

## Temporal Workflow
[temporal-workflow.md](temporal-workflow.md)
- Temporal integration
- State management
- Reliability features
- Monitoring capabilities

## Using These Diagrams

These diagrams are written in Mermaid markdown format. To view them:
1. Use a Mermaid-compatible markdown viewer
2. View directly in GitHub (which supports Mermaid)
3. Use the [Mermaid Live Editor](https://mermaid.live) to edit or export

## Diagram Conventions

Colors indicate component types:
- Pink (#f9f) - Core components
- Blue (#bbf) - External systems/state
- Green (#bfb) - Features/handlers
- Red (#fbb) - Monitoring components
